<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Tock Register Interface"><meta name="keywords" content="rust, rustlang, rust-lang, tock_registers"><title>tock_registers - Rust</title><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../ayu.css" disabled ><script id="default-settings" ></script><script src="../storage.js"></script><script src="../crates.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../favicon.svg"><style type="text/css">#crate-search{background-image:url("../down-arrow.svg");}</style></head><body class="rustdoc mod crate"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../tock_registers/index.html'><div class='logo-container rust-logo'><img src='../rust-logo.png' alt='logo'></div></a><h2 class="location">Crate tock_registers</h2><div class="block version"><div class="narrow-helper"></div><p>Version 0.7.0</p></div><div class="sidebar-elems"><a id="all-types" href="all.html"><p>See all tock_registers's items</p></a><div class="block items"><ul><li><a href="#modules">Modules</a></li><li><a href="#macros">Macros</a></li><li><a href="#structs">Structs</a></li><li><a href="#traits">Traits</a></li></ul></div><div id="sidebar-vars" data-name="tock_registers" data-ty="mod" data-relpath=""></div><script defer src="sidebar-items.js"></script></div></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../wheel.svg"></a></div></form></nav><section id="main" class="content"><h1 class="fqn"><span class="in-band">Crate <a class="mod" href="#">tock_registers</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span><span class="out-of-band"><span id="render-detail"><a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span><a class="srclink" href="../src/tock_registers/lib.rs.html#1-129" title="goto source code">[src]</a></span></h1><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Tock Register Interface</p>
<p>Provides efficient mechanisms to express and use type-checked
memory mapped registers and bitfields.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code>
<span class="kw">use</span> <span class="ident">tock_registers::registers</span>::{<span class="ident">ReadOnly</span>, <span class="ident">ReadWrite</span>};
<span class="kw">use</span> <span class="ident">tock_registers::register_bitfields</span>;

<span class="comment">// Register maps are specified like this:</span>
<span class="attribute">#[<span class="ident">repr</span>(<span class="ident">C</span>)]</span>
<span class="kw">struct</span> <span class="ident">Registers</span> {
    <span class="comment">// Control register: read-write</span>
    <span class="ident">cr</span>: <span class="ident">ReadWrite</span><span class="op">&lt;</span><span class="ident">u32</span>, <span class="ident">Control::Register</span><span class="op">&gt;</span>,
    <span class="comment">// Status register: read-only</span>
    <span class="ident">s</span>: <span class="ident">ReadOnly</span><span class="op">&lt;</span><span class="ident">u32</span>, <span class="ident">Status::Register</span><span class="op">&gt;</span>,
}

<span class="comment">// Register fields and definitions look like this:</span>
<span class="macro">register_bitfields!</span>[<span class="ident">u32</span>,
    <span class="comment">// Simpler bitfields are expressed concisely:</span>
    <span class="ident">Control</span> [
        <span class="doccomment">/// Stop the Current Transfer</span>
        <span class="ident">STOP</span> <span class="number">8</span>,
        <span class="doccomment">/// Software Reset</span>
        <span class="ident">SWRST</span> <span class="number">7</span>,
        <span class="doccomment">/// Master Disable</span>
        <span class="ident">MDIS</span> <span class="number">1</span>,
        <span class="doccomment">/// Master Enable</span>
        <span class="ident">MEN</span> <span class="number">0</span>
    ],

    <span class="comment">// More complex registers can express subtypes:</span>
    <span class="ident">Status</span> [
        <span class="ident">TXCOMPLETE</span>  <span class="ident">OFFSET</span>(<span class="number">0</span>) <span class="ident">NUMBITS</span>(<span class="number">1</span>) [],
        <span class="ident">TXINTERRUPT</span> <span class="ident">OFFSET</span>(<span class="number">1</span>) <span class="ident">NUMBITS</span>(<span class="number">1</span>) [],
        <span class="ident">RXCOMPLETE</span>  <span class="ident">OFFSET</span>(<span class="number">2</span>) <span class="ident">NUMBITS</span>(<span class="number">1</span>) [],
        <span class="ident">RXINTERRUPT</span> <span class="ident">OFFSET</span>(<span class="number">3</span>) <span class="ident">NUMBITS</span>(<span class="number">1</span>) [],
        <span class="ident">MODE</span>        <span class="ident">OFFSET</span>(<span class="number">4</span>) <span class="ident">NUMBITS</span>(<span class="number">3</span>) [
            <span class="ident">FullDuplex</span> <span class="op">=</span> <span class="number">0</span>,
            <span class="ident">HalfDuplex</span> <span class="op">=</span> <span class="number">1</span>,
            <span class="ident">Loopback</span> <span class="op">=</span> <span class="number">2</span>,
            <span class="ident">Disabled</span> <span class="op">=</span> <span class="number">3</span>
        ],
        <span class="ident">ERRORCOUNT</span> <span class="ident">OFFSET</span>(<span class="number">6</span>) <span class="ident">NUMBITS</span>(<span class="number">3</span>) []
    ]
];</code></pre></div>
<h2 id="author" class="section-header"><a href="#author">Author</a></h2>
<ul>
<li>Shane Leonard <a href="mailto:shanel@stanford.edu">shanel@stanford.edu</a></li>
</ul>
</div></details><h2 id="modules" class="section-header"><a href="#modules">Modules</a></h2>
<div class="item-table"><div class="item-left module-item"><a class="mod" href="fields/index.html" title="tock_registers::fields mod">fields</a></div><div class="item-right docblock-short"><p>Register bitfield types and macros</p>
</div><div class="item-left module-item"><a class="mod" href="interfaces/index.html" title="tock_registers::interfaces mod">interfaces</a></div><div class="item-right docblock-short"><p>Interfaces (traits) to register types</p>
</div><div class="item-left module-item"><a class="mod" href="macros/index.html" title="tock_registers::macros mod">macros</a></div><div class="item-right docblock-short"><p>Macros for cleanly defining peripheral registers.</p>
</div><div class="item-left module-item"><a class="mod" href="registers/index.html" title="tock_registers::registers mod">registers</a></div><div class="item-right docblock-short"><p>Implementation of included register types.</p>
</div></div><h2 id="macros" class="section-header"><a href="#macros">Macros</a></h2>
<div class="item-table"><div class="item-left module-item"><a class="macro" href="macro.bitmask.html" title="tock_registers::bitmask macro">bitmask</a></div><div class="item-right docblock-short"><p>Helper macro for computing bitmask of variable number of bits</p>
</div><div class="item-left module-item"><a class="macro" href="macro.register_bitfields.html" title="tock_registers::register_bitfields macro">register_bitfields</a></div><div class="item-right docblock-short"><p>Define register types and fields.</p>
</div><div class="item-left module-item"><a class="macro" href="macro.register_bitmasks.html" title="tock_registers::register_bitmasks macro">register_bitmasks</a></div><div class="item-right docblock-short"><p>Helper macro for defining register fields.</p>
</div><div class="item-left module-item"><a class="macro" href="macro.register_fields.html" title="tock_registers::register_fields macro">register_fields</a></div><div class="item-right docblock-short"></div><div class="item-left module-item"><a class="macro" href="macro.register_structs.html" title="tock_registers::register_structs macro">register_structs</a></div><div class="item-right docblock-short"></div><div class="item-left module-item"><a class="macro" href="macro.test_fields.html" title="tock_registers::test_fields macro">test_fields</a></div><div class="item-right docblock-short"></div></div><h2 id="structs" class="section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-left module-item"><a class="struct" href="struct.LocalRegisterCopy.html" title="tock_registers::LocalRegisterCopy struct">LocalRegisterCopy</a></div><div class="item-right docblock-short"><p>A read-write copy of register contents.</p>
</div></div><h2 id="traits" class="section-header"><a href="#traits">Traits</a></h2>
<div class="item-table"><div class="item-left module-item"><a class="trait" href="trait.RegisterLongName.html" title="tock_registers::RegisterLongName trait">RegisterLongName</a></div><div class="item-right docblock-short"><p>Descriptive name for each register.</p>
</div><div class="item-left module-item"><a class="trait" href="trait.UIntLike.html" title="tock_registers::UIntLike trait">UIntLike</a></div><div class="item-right docblock-short"><p>Trait representing the base type of registers.</p>
</div></div></section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../" data-current-crate="tock_registers" data-search-index-js="../search-index.js" data-search-js="../search.js"></div>
    <script src="../main.js"></script>
</body></html>